%define desktop_file_utils_version 0.9
%define nspr_version 4.7
%define nss_version 3.12
%define cairo_version 1.6
%define pango_version 1.10
%define gtk2_version 2.10
%define dbus_glib_version 0.6
%define telepathy_glib_version 0.7.9

Summary:        Synovel Spicebird PIM client
Name:           spicebird
Version:        0.7.1
Release:        1%{?dist}
URL:            http://www.spicebird.org/
License:        GPLv2+
Group:          Applications/Internet
%define tarball spicebird-beta-%{version}-full_source.tar.bz2
Source0:        http://files.spicebird.org/pub/spicebird.org/spicebird/releases/latest/source/%{tarball}
Source1:        http://bunny.medhas.org/download/spicebird-beta-langpacks-%{version}-20090326.tar.bz2
Source10:       spicebird-mozconfig
Source12:       spicebird-redhat-default-prefs.js
Source20:       spicebird.desktop
Source21:       spicebird.sh.in
Source22:       spicebird.png
Source30:       spicebird-open-browser.sh
Source100:      find-external-requires

Patch1:         spicebird.gcc4.4.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires:       nspr >= %{nspr_version}
Requires:       nss >= %{nss_version}
Requires:       telepathy-haze
%if 0%{?rhel} >= 5
Requires:       launchmail
%endif
BuildRequires:  cairo-devel >= %{cairo_version}
BuildRequires:  libjpeg-devel
BuildRequires:  gtk2-devel >= %{gtk2_version}
BuildRequires:  pango-devel >= %{pango_version}
BuildRequires:  GConf2-devel
BuildRequires:  gnome-vfs2-devel
BuildRequires:  libgnomeui-devel
BuildRequires:  zlib-devel, gzip, zip, unzip
BuildRequires:  nspr-devel >= %{nspr_version}
BuildRequires:  nss-devel >= %{nss_version}
BuildRequires:  libIDL-devel
BuildRequires:  desktop-file-utils
BuildRequires:  freetype-devel
BuildRequires:  libXt-devel
BuildRequires:  libXrender-devel
BuildRequires:  dbus-glib-devel >= %{dbus_glib_version}
BuildRequires:  telepathy-glib-devel >= %{telepathy_glib_version}
BuildRequires:  libxml2-devel
BuildRequires:  startup-notification-devel
Requires:       desktop-file-utils >= %{desktop_file_utils_version}

%define mozappdir %{_libdir}/spicebird-beta-%{version}

AutoProv: 0
%define _use_internal_dependency_generator 0
%define __find_requires %{SOURCE100}

%description
Synovel Spicebird provides email, calendaring and instant messaging with tight integration

#===============================================================================

%prep
%setup -q -c
cd mozilla

%patch1 -p1 -b .gcc

%{__rm} -f .mozconfig
%{__cp} %{SOURCE10} .mozconfig

#===============================================================================

%build
cd mozilla

# Build with -Os as it helps the browser; also, don't override mozilla's warning
# level; they use -Wall but disable a few warnings that show up _everywhere_
#MOZ_OPT_FLAGS=$(echo $RPM_OPT_FLAGS | %{__sed} -e 's/-O2/-Os/' -e 's/-Wall//')

# Mozilla builds with -Wall with exception of a few warnings show up
# everywhere in the code; so, don't override that.
MOZ_OPT_FLAGS=$(echo $RPM_OPT_FLAGS | %{__sed} -e 's/-Wall//')
export CFLAGS=$MOZ_OPT_FLAGS
export CXXFLAGS=$MOZ_OPT_FLAGS

#export RPM_OPT_FLAGS=$MOZ_OPT_FLAGS
export PREFIX='%{_prefix}'
export LIBDIR='%{_libdir}'

#%ifarch ppc ppc64 s390 s390x
#%define moz_make_flags -j1
#%else
#%define moz_make_flags %{?_smp_mflags}

MOZ_SMP_FLAGS=-j1
%ifnarch ppc ppc64 s390 s390x
[ -z "$RPM_BUILD_NCPUS" ] && \
    RPM_BUILD_NCPUS="`/usr/bin/getconf _NPROCESSORS_ONLN`"
[ "$RPM_BUILD_NCPUS" -gt 1 ] && MOZ_SMP_FLAGS=-j$RPM_BUILD_NCPUS
%endif

export LDFLAGS="-Wl,-rpath,%{mozappdir}"
#export MAKE="gmake %{moz_make_flags}"
#make -f client.mk build

make -f client.mk build STRIP="/bin/true" MOZ_MAKE_FLAGS="$MOZ_SMP_FLAGS"

#===============================================================================

%install
%{__rm} -rf $RPM_BUILD_ROOT
cd mozilla

DESTDIR=$RPM_BUILD_ROOT make install

%{__mkdir_p} $RPM_BUILD_ROOT{%{_libdir},%{_bindir},%{_datadir}/applications,%{_datadir}/icons/hicolor/48x48/apps}

%{__install} -p -D %{SOURCE22} $RPM_BUILD_ROOT%{_datadir}/pixmaps/%{name}.png

desktop-file-install --vendor synovel \
  --dir $RPM_BUILD_ROOT%{_datadir}/applications \
  --add-category Network \
  --add-category Email \
  --add-category Office \
  %{SOURCE20}

# set up the thunderbird start script
%{__cat} %{SOURCE21} | %{__sed} -e 's,SPICEBIRD_VERSION,%{version},g' > \
  $RPM_BUILD_ROOT%{_bindir}/spicebird
%{__chmod} 755 $RPM_BUILD_ROOT/%{_bindir}/spicebird

%{__install} -m755 %{SOURCE30} $RPM_BUILD_ROOT/%{mozappdir}/open-browser.sh
%{__sed} -i -e 's|LIBDIR|%{_libdir}|g' $RPM_BUILD_ROOT/%{mozappdir}/open-browser.sh

# set up our default preferences
%{__cat} %{SOURCE12} | %{__sed} -e 's,SPICEBIRD_RPM_VR,%{version}-%{release},g' \
                                -e 's,COMMAND,%{mozappdir}/open-browser.sh,g' > \
        $RPM_BUILD_ROOT/rh-default-prefs
%{__cp} $RPM_BUILD_ROOT/rh-default-prefs $RPM_BUILD_ROOT/%{mozappdir}/greprefs/all-redhat.js
%{__cp} $RPM_BUILD_ROOT/rh-default-prefs $RPM_BUILD_ROOT/%{mozappdir}/defaults/pref/all-redhat.js
%{__rm} $RPM_BUILD_ROOT/rh-default-prefs

%{__rm} -f $RPM_BUILD_ROOT%{_bindir}/spicebird-config

cd $RPM_BUILD_ROOT%{mozappdir}/chrome
find . -name "*" -type d -maxdepth 1 -exec %{__rm} -rf {} \;
cd -

# own mozilla plugin dir (#135050)
%{__mkdir_p} $RPM_BUILD_ROOT%{_libdir}/mozilla/plugins

# Install langpacks
%{__rm} -f ../%{name}.lang
touch ../%{name}.lang
%{__mkdir_p} $RPM_BUILD_ROOT%{mozappdir}/extensions
%{__tar} xjf %{SOURCE1}
for langpack in `ls spicebird-langpacks/*.xpi`; do
  language=`basename $langpack .xpi`
  extensiondir=$RPM_BUILD_ROOT%{mozappdir}/extensions/langpack-$language@spicebird.org
  %{__mkdir_p} $extensiondir
  unzip $langpack -d $extensiondir
  find $extensiondir -type f | xargs chmod 644

  tmpdir=`mktemp -d %{name}.XXXXXXXX`
  langtmp=$tmpdir/%{name}/langpack-$language
  %{__mkdir_p} $langtmp
  jarfile=$extensiondir/chrome/$language.jar
  unzip $jarfile -d $langtmp

  find $langtmp -type f | xargs chmod 644
  %{__rm} -rf $jarfile
  cd $langtmp
  zip -r -D $jarfile locale
  %{__rm} -rf locale
  cd -
  %{__rm} -rf $tmpdir

  language=`echo $language | sed -e 's/-/_/g'`
  extensiondir=`echo $extensiondir | sed -e "s,^$RPM_BUILD_ROOT,,"`
  echo "%%lang($language) $extensiondir" >> ../%{name}.lang
done
%{__rm} -rf spicebird-langpacks


# Copy over the LICENSE
%{__install} -c -m 644 LICENSE $RPM_BUILD_ROOT%{mozappdir}

# Use the system hunspell dictionaries
%{__rm} -rf $RPM_BUILD_ROOT/%{mozappdir}/dictionaries
ln -s %{_datadir}/myspell $RPM_BUILD_ROOT%{mozappdir}/dictionaries

# ghost files
touch $RPM_BUILD_ROOT%{mozappdir}/components/compreg.dat
touch $RPM_BUILD_ROOT%{mozappdir}/components/xpti.dat


%clean
%{__rm} -rf $RPM_BUILD_ROOT

%post
update-desktop-database &> /dev/null || :
touch --no-create %{_datadir}/icons/hicolor
if [ -x %{_bindir}/gtk-update-icon-cache ]; then
  %{_bindir}/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor || :
fi

%postun
update-desktop-database &> /dev/null || :
touch --no-create %{_datadir}/icons/hicolor
if [ -x %{_bindir}/gtk-update-icon-cache ]; then
  %{_bindir}/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor || :
fi

%files -f %{name}.lang
%defattr(-,root,root,-)
%attr(755,root,root) %{_bindir}/spicebird
%attr(644,root,root) %{_datadir}/applications/synovel-spicebird.desktop
%attr(644,root,root) %{_datadir}/pixmaps/spicebird.png
%dir %{mozappdir}
%doc %{mozappdir}/LICENSE
%doc %{mozappdir}/README.txt
%doc %{mozappdir}/application.ini
%{mozappdir}/chrome
%dir %{mozappdir}/components
%ghost %{mozappdir}/components/compreg.dat
%ghost %{mozappdir}/components/xpti.dat
%{mozappdir}/components/*.so
%{mozappdir}/components/*.xpt
%attr(644,root,root) %{mozappdir}/components/*.js
%{mozappdir}/defaults
%{mozappdir}/dependentlibs.list
%{mozappdir}/dictionaries
%dir %{mozappdir}/extensions
%{mozappdir}/extensions/{972ce4c6-7e08-4474-a285-3208198ce6fd}
%{mozappdir}/extensions/{a62ef8ec-5fdc-40c2-873c-223b8a6925cc}
%{mozappdir}/greprefs
%{mozappdir}/icons
%{mozappdir}/isp
%dir %{mozappdir}/js
%{mozappdir}/js/*.js
%doc %{mozappdir}/license.html
%dir %{mozappdir}/modules
%{mozappdir}/modules/*.js
%{mozappdir}/modules/*.jsm
%{mozappdir}/mozilla-xremote-client
%{mozappdir}/open-browser.sh
%{mozappdir}/platform.ini
%{mozappdir}/res
%{mozappdir}/run-mozilla.sh
%{mozappdir}/spicebird-bin
%{mozappdir}/spicebird
%{mozappdir}/timezones.sqlite
%{mozappdir}/updater*
%{mozappdir}/*.so
%exclude %{mozappdir}/removed-files
%exclude %{_bindir}/spicebird-beta

#===============================================================================

%changelog
* Sun Mar 29 2009 Steven M. Parrish <tuxbrewr@fedoraproject.org> 0.7.1-1 
- New Upstream release

* Thu Feb 26 2009 Steven M. Parrish <tuxbrewr@fedoraproject.org> 0.7-6
- Fix missing file build error

* Thu Feb 26 2009 Steven M. Parrish <tuxbrewr@fedoraproject.org> 0.7-5
- Fix missing file build error

* Thu Feb 26 2009 Steven M. Parrish <tuxbrewr@fedoraproject.org> - 0.7-4
- Fix build error when using gcc4.4

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.7-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Mon Dec 29 2008 Steven M. Parrish <tuxbrewr@fedoraproject.org> 0.7-2
- Updated SPEC file to address https://bugzilla.redhat.com/show_bug.cgi?id=453936#c16

* Wed Dec 24 2008 Sunil Mohan Adapa <sunil@synovel.com> 0.7-1
- Initial verison based on Thundebird RPM work

